<?
/**
 * avvia la sezione
 * se non esiste ne crea una nuova
 *
 *
 * @name instancemanager
 *
 * @param string $object nome dell' oggetto
 * @param string instancename il nome dell' istanza
 * @param string root di mosaicox2
 **/

function instancemanager($object, $instancename, $app_path = "./")
{
	require_once ($app_path."libs/MoasInstance.php");
	require_once ($app_path."libs/debug.php");
	require_once ($app_path."libs/MoasObjects.php");
	session_start();
	if (isset($_SESSION['semaforo']) && $_SESSION['semaforo']==1 && !isset($_GET['logout']))
	{
		echo "_moasinstancebusy";
		return;
	}
	$_SESSION['semaforo']=0;

	//------continua la sessione ---------
	$thisfile = basename($_SERVER['PHP_SELF']);
	// ------------------  definizione oggetto di default  -------------------------
	// distrugge la sessione e elimina le classi serializzate in essa
	if (isset ($_GET['logout'])) //cambiare in moasclassdestroy
	{
		$_SESSION[$instancename] = null;
	}
	ProcessPost();

	//------- nuova istanza, genero l'istanza di default e apro la sessione --------
	if (!isset ($_SESSION[$instancename]) || $_SESSION[$instancename] == null ||
	! is_object($_SESSION[$instancename]))
	{
		$xmlstr = get_xml_object_from_file($object);
		$_SESSION[$instancename] = new MoasInstance($xmlstr);
		$MoasInstance = &$_SESSION[$instancename];

		//-------processa i post --------
		//modifica l' istanza con i post
		post2instance($MoasInstance->instance);
		//------include gli oggetti associati all'istanza
		$MoasInstance->DeclareObjectsLibs();
	}
	else
	{
		$MoasInstance=&$_SESSION[$instancename];
		$MoasInstance->IncludeObjectsFunctions();
		post2instance($MoasInstance->instance);
		if (isset($MoasInstance->_classlist) && is_array($MoasInstance->_classlist))
			foreach ($MoasInstance->_classlist as $key => $val)
			{
				if (is_string($MoasInstance->_classlist[$key]))
					$MoasInstance->_classlist[$key]=unserialize($MoasInstance->_classlist[$key]);
				else
					dprint_r($MoasInstance->_classlist[$key]);
			}
	}


	//------associa post e get all'istanza-------
	//	post2instance($MoasInstance->instance);


	$action=isset($_GET['action']) ? $_GET['action']:null;
	if ($action==null)
		$action=isset($_POST['action']) ? $_POST['action']:null;

	if ($action!=null)
	{
		//----------- chiama la funzione che modifica l'istanza ------------------------
		$fname = $action;
		if (strstr($action,"."))
		{
			$base=explode(".",$fname);
			if (isset($MoasInstance->_classlist[$base[0]]) && is_object($MoasInstance->_classlist[$base[0]]))
			{
				$pointerclass=$MoasInstance->_classlist[$base[0]];
				$pointerclass->path=$base[0];
				if ($pointerclass->path!="")
					$pointerclass->path.=":";
				$pointerclass->instance=&$MoasInstance->instance;
				//esegue la action
				$pointerclass->$base[1]($MoasInstance,$pointerclass->path);
			}
			else
			{
				echo "classlist[".$base[0]."]->".$base[1]." not exists";
			}
		}
		else
			if (function_exists($fname))
			{
				$fname ($MoasInstance); //ritorna l'istanza modificata e la memorizzo
			}	
		 	else
			{
				//ho chiamato una funzione che non esiste !!!
				echo "function $fname not exists";
			}
	}


	$tree=(isset($_GET['gettree']))?$_GET['gettree']:null;
	$xhtml = $MoasInstance->getXMLClean($tree);
	
	//serializzaione delle classi instanziate
	if (isset($MoasInstance->_classlist) && is_array($MoasInstance->_classlist))
		foreach ($MoasInstance->_classlist as $key => $val)
			$MoasInstance->_classlist[$key]=serialize($MoasInstance->_classlist[$key]);

	echo ($xhtml);
	$_SESSION['semaforo']=0;
	
	//dprint_xml($MoasInstance->getXML());

//dprint_r($MoasInstance->_classlist);
}
?>